;INIT disk catalogs
;inits whole disk
;& destroys ccats - something like format c:/q in DOS.
;Version for 8-bit simple interface ROM

WRIBE	EQU	#57E

	ORG	40000
	LD	HL,BEG
	LD	A,1
	LD	DE,0
	LD	BC,0
	CALL	WRIBE
	LD	IX,BEG
	LD	HL,WORK
	LD	DE,20000
CLWL	LD	(HL),0
	INC	HL
	DEC	DE
	LD	A,D
	OR	E
	JR	NZ,CLWL

	LD	B,36
ICCAL	PUSH	BC
	LD	HL,WORK
	LD	C,(IX+3)
	LD	(HL),C
	INC	HL
	LD	(HL),0 ;fds
	INC	HL
	LD	A,(IX+4)
	LD	(HL),A
	INC	HL
	LD	A,(IX+5)
	LD	(HL),A ;tsa
	INC	HL
	LD	(HL),C ;fds
	INC	HL
	LD	A,(IX+0)
	LD	(HL),A ;char of area
	INC	HL
	LD	E,(IX+1)
	LD	(HL),E
	INC	HL
	LD	D,(IX+2)
	LD	(HL),D ;cyl offset of area
	LD	A,C
	LD	BC,0
	LD	HL,WORK
	CALL	WRIBE
	LD	BC,6
	ADD	IX,BC
	POP	BC
	DJNZ	ICCAL
	RET

;MASTER CAT SECTOR
;Geometry of disk is 7 head, 17 sector/track

SPY	EQU	119 ;sector per cylinder


BEG	DEFB	"A"
	DEFW	5  ; starting sector of area
	DEFB	21 ; first data sector 
	DEFW	60*SPY ; total length in sectors of area = tracks*sector per cyl.
	
MB	DEFB	"B"
	DEFW	65
	DEFB	21
	DEFW	60*SPY
	
MC	DEFB	"C"
	DEFW	152
	DEFB	16
	DEFW	45*SPY
	
MD	DEFB	"D"
	DEFW	197
	DEFB	19
	DEFW	50*SPY
	
ME	DEFB	"E"
	DEFW	247
	DEFB	11
	DEFW	30*SPY
	
MF	DEFB	"F"
	DEFW	277
	DEFB	13
	DEFW	40*SPY
	
MG	DEFB	"G"
	DEFW	317
	DEFB	13
	DEFW	40*SPY
	
MH	DEFB	"H"
	DEFW	357
	DEFB	6
	DEFW	30*SPY
	
MI	DEFB	"I"
	DEFW	125
	DEFB	6
	DEFW	15*SPY
	
MJ	DEFB	"J"
	DEFW	387
	DEFB	8
	DEFW	20*SPY
	
MK	DEFB	"K"
	DEFW	407
	DEFB	8
	DEFW	20*SPY
	
ML	DEFB	"L"
	DEFW	427
	DEFB	8
	DEFW	20*SPY
	
MM	DEFB	"M"
	DEFW	447
	DEFB	21
	DEFW	60*SPY
	
MN	DEFB	"N"
	DEFW	507
	DEFB	11
	DEFW	30*SPY
	
MO	DEFB	"O"
	DEFW	139
	DEFB	5
	DEFW	10*SPY
	
MP	DEFB	"P"
	DEFW	537
	DEFB	13
	DEFW	40*SPY
	
MQ	DEFB	"Q"
	DEFW	755
	DEFB	4
	DEFW	10*SPY
	
MR	DEFB	"R"
	DEFW	784
	DEFB	8
	DEFW	20*SPY
	
MS	DEFB	"S"
	DEFW	665
	DEFB	31
	DEFW	90*SPY
	
MT	DEFB	"T"
	DEFW	577
	DEFB	25
	DEFW	70*SPY
	
MU	DEFB	"U"
	DEFW	647
	DEFB	6
	DEFW	15*SPY
	
MV	DEFB	"V"
	DEFW	804
	DEFB	11
	DEFW	30*SPY
	
MW	DEFB	"W"
	DEFW	765
	DEFB	6
	DEFW	15*SPY
	
MX	DEFB	"X"
	DEFW	834
	DEFB	4
	DEFW	10*SPY
	
MY	DEFB	"Y"
	DEFW	844
	DEFB	4
	DEFW	10*SPY
	
MZ	DEFB	"Z"
	DEFW	854
	DEFB	4
	DEFW	10*SPY
	
M0	DEFB	"0"
	DEFW	864
	DEFB	6
	DEFW	15*SPY
	
M1	DEFB	"1"
	DEFW	879
	DEFB	6
	DEFW	15*SPY
	
M2	DEFB	"2"
	DEFW	894
	DEFB	6
	DEFW	15*SPY
	
M3	DEFB	"3"
	DEFW	909
	DEFB	6
	DEFW	15*SPY
	
M4	DEFB	"4"
	DEFW	924
	DEFB	6
	DEFW	15*SPY
	
M5	DEFB	"5"
	DEFW	939
	DEFB	6
	DEFW	15*SPY
	
M6	DEFB	"6"
	DEFW	954
	DEFB	6
	DEFW	15*SPY
	
M7	DEFB	"7"
	DEFW	969
	DEFB	6
	DEFW	15*SPY
	
M8	DEFB	"8"
	DEFW	984
	DEFB	6
	DEFW	15*SPY
	
M9	DEFB	"9"
	DEFW	999
	DEFB	6
	DEFW	15*SPY
	
	DEFS	80
WORK

